//+------------------------------------------------------------------+
//|                                    smInvictus AtrRangeFilter.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011.11.15, SwingMan"
#property link      ""

string indicatorName ="smInvictus AtrRangeFilter_v3";
//+------------------------------------------------------------------+
//  2011.11.14 v1 - 
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_buffers 5

#property indicator_color1 Green       // OK long
#property indicator_color2 Red         // OK short
#property indicator_color3 Silver      // not OK
#property indicator_color4 DodgerBlue       // OK long arrow
#property indicator_color5 Magenta          // OK short arrow

#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 1
#property indicator_width5 1

#property indicator_maximum 12
#property indicator_minimum 0

//---- input parameters
//+------------------------------------------------------------------+
extern int timeFrame=0;
extern string ____Trading = "----------------------";
extern int Target_Points   = 10;
extern int Stoploss_Points = 20;
extern string ____ATR = "-------------------------------------";
extern int ATR_Period1       = 5;
extern int ATR_Period2       = 25;
extern double  RoomLimitRatio=0.20;
extern string ____DrawSignals = "----------------------";
extern bool Draw_SignalLines   = false;
extern bool Draw_TradingArrows = true;
extern bool Draw_SignalArrows  = true;
bool Draw_M15Histograms = false;
extern string ____CheckSignals = "----------------------";
extern bool Comment_CheckSignals = true;
extern string Check_DateTime = "";
//extern string Check_DateTime = "2011.11.13 23:30";
//+------------------------------------------------------------------+
bool ExcludeSundayData=true;
int maxBars= 2000;
int LastBars0 = 0;
int indValue= 5;
int sigOffset=2;
//+------------------------------------------------------------------+

//---- buffers
double filterUpOK[],filterDnOK[],filterNOK[];
double AtrBuffer1,AtrBuffer2;
double SignalUp[],SignalDn[];

//---- variables
bool newVertLine= true;
datetime thisTime,oldTime;
bool newBar;
double dPoint;
int multiplier;
string indicatorFileName;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   indicatorFileName = WindowExpertName();
   timeFrame = MathMax(timeFrame,_Period);
   string short_name;
   short_name=indicatorName +
              " (" + ATR_Period1 + "," + ATR_Period2+ ") ";              
   IndicatorShortName(short_name);   
   oldTime=0;

//---- indicator line   
   SetIndexBuffer(0,filterUpOK); SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexLabel(0,"Buy OK");
   SetIndexBuffer(1,filterDnOK); SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexLabel(1,"Sell OK");
   SetIndexBuffer(2,filterNOK);  SetIndexStyle(2,DRAW_HISTOGRAM); SetIndexLabel(2,"Trade NOK");
   //--
   int iArrowUP= 217;
   int iArrowDN= 218;
   SetIndexBuffer(3,SignalUp);   SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,iArrowUP);   
   SetIndexBuffer(4,SignalDn);   SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,iArrowDN);
   SetIndexLabel(3,"Buy Signal");
   SetIndexLabel(4,"Sell Signal");

//----
   int maxPeriod= ATR_Period2;
   SetIndexDrawBegin(0,maxPeriod);
   SetIndexDrawBegin(1,maxPeriod);
   SetIndexDrawBegin(2,maxPeriod);
   SetIndexDrawBegin(3,maxPeriod);
   SetIndexDrawBegin(4,maxPeriod);
   
   IndicatorDigits(0);   
   
//----   
   dPoint = Point;
   if(Digits == 2 || Digits == 4) multiplier = 1;
   if(Digits == 3 || Digits == 5) multiplier = 10;
   dPoint     *= multiplier;
//----
   return(0);
}

int deinit()
{
   if (Comment_CheckSignals) Comment("");
   Delete_Objects("Signal");
   return(0);
}

//+------------------------------------------------------------------+
//|   get trading filter
//+------------------------------------------------------------------+
int start()
{
   int i,counted_bars=IndicatorCounted();
//----
   i=Bars-counted_bars-1;
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   if (limit>maxBars && maxBars!=0) limit=maxBars;
   
//----   
   if (timeFrame!=_Period)
   {
      limit = MathMin(MathMax(limit,3*timeFrame/_Period),Bars-1);
      for(i=limit; i>=0; i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
         filterUpOK[i] = iCustom(NULL,timeFrame,indicatorFileName,0,"",Target_Points,Stoploss_Points,"",ATR_Period1,ATR_Period2,RoomLimitRatio,"",Draw_SignalLines,Draw_TradingArrows,Draw_SignalArrows,"",Comment_CheckSignals,Check_DateTime,0,y);
         filterDnOK[i] = iCustom(NULL,timeFrame,indicatorFileName,0,"",Target_Points,Stoploss_Points,"",ATR_Period1,ATR_Period2,RoomLimitRatio,"",Draw_SignalLines,Draw_TradingArrows,Draw_SignalArrows,"",Comment_CheckSignals,Check_DateTime,1,y);
         filterNOK[i]  = iCustom(NULL,timeFrame,indicatorFileName,0,"",Target_Points,Stoploss_Points,"",ATR_Period1,ATR_Period2,RoomLimitRatio,"",Draw_SignalLines,Draw_TradingArrows,Draw_SignalArrows,"",Comment_CheckSignals,Check_DateTime,2,y);
         if (y!=iBarShift(NULL,timeFrame,Time[i+1]))
         {
            SignalUp[i] = iCustom(NULL,timeFrame,indicatorFileName,0,"",Target_Points,Stoploss_Points,"",ATR_Period1,ATR_Period2,RoomLimitRatio,"",Draw_SignalLines,Draw_TradingArrows,Draw_SignalArrows,"",Comment_CheckSignals,Check_DateTime,3,y);
            SignalDn[i] = iCustom(NULL,timeFrame,indicatorFileName,0,"",Target_Points,Stoploss_Points,"",ATR_Period1,ATR_Period2,RoomLimitRatio,"",Draw_SignalLines,Draw_TradingArrows,Draw_SignalArrows,"",Comment_CheckSignals,Check_DateTime,4,y);
         }
         else
         {
            SignalUp[i] = EMPTY_VALUE;
            SignalDn[i] = EMPTY_VALUE;
         }            
      }
      return(0);
   }
   for(i=limit; i>=0; i--)
   {        
            //=======================================================
            //       HeikinAshi candles         
            //=======================================================
      double haOpenM15 =  iCustom(NULL, PERIOD_M15, "Heiken Ashi", 2, i);
      double haCloseM15 = iCustom(NULL, PERIOD_M15, "Heiken Ashi", 3, i);      
      bool bHashiUpM15 = (haCloseM15 > haOpenM15);
      bool bHashiDnM15 = (haCloseM15 < haOpenM15);
      //--
      int iH1= iBarShift(Symbol(),PERIOD_H1,Time[i],false);
      double haOpenH1 =  iCustom(NULL, PERIOD_H1, "Heiken Ashi", 2, iH1);
      double haCloseH1 = iCustom(NULL, PERIOD_H1, "Heiken Ashi", 3, iH1);      
      bool bHashiUpH1 = (haCloseH1 > haOpenH1);
      bool bHashiDnH1 = (haCloseH1 < haOpenH1);
      //--
      int iH4= iBarShift(Symbol(),PERIOD_H4,Time[i],false);
      double haOpenH4 =  iCustom(NULL, PERIOD_H4, "Heiken Ashi", 2, iH4);
      double haCloseH4 = iCustom(NULL, PERIOD_H4, "Heiken Ashi", 3, iH4);      
      bool bHashiUpH4 = (haCloseH4 > haOpenH4);
      bool bHashiDnH4 = (haCloseH4 < haOpenH4);
      //--
      bool bHashiUp= (bHashiUpM15 && bHashiUpH1 && bHashiUpH4); //##
      bool bHashiDn= (bHashiDnM15 && bHashiDnH1 && bHashiDnH4); //##
      
      //== check new bar ============================================
      thisTime=Time[i];
      if (thisTime>oldTime)
      {
         oldTime= thisTime;
         newBar= true;
      }
      else
         newBar= false;
      
      if (newBar)
      {
            //=======================================================
            //       ATR (Average True Range)
            //=======================================================
         static int atr1, atr2;
         static bool bAtrFilter;
         AtrBuffer1= iATR(Symbol(),Period(),ATR_Period1,i+1); //-- ATR for the previous bar
         AtrBuffer2= iATR(Symbol(),Period(),ATR_Period2,i+1); 
         atr1 = MathRound(AtrBuffer1 / Point);
         atr2 = MathRound(AtrBuffer2 / Point);     
            
         //bAtrFilter= (atr1 > atr2); //## compare with rounding values
         bAtrFilter= (AtrBuffer1 > AtrBuffer2); //## compare without rounding values
       
            //=======================================================
            //       ADR (Average Daily Range)
            //=======================================================
         int n = 1;        
         static int adr1, adr5, adr10, adr20, adr;
         double s = 0.0;    
      
         //-- 20 days loop
         int iD1= iBarShift(Symbol(),PERIOD_D1,Time[i],false);

         for(int rng=1; rng<=20; rng++)
         {
            while(ExcludeSundayData && TimeDayOfWeek(iTime(NULL, PERIOD_D1, iD1+n)) == 0) 
               n++;
            s = s + (iHigh(NULL, PERIOD_D1, iD1+n) - iLow(NULL, PERIOD_D1, iD1+n)) / Point;

            if(rng == 1)  adr1  = MathRound(s);
            if(rng == 5)  adr5  = MathRound(s/5);
            if(rng == 10) adr10 = MathRound(s/10);
            if(rng == 20) adr20 = MathRound(s/20);
            n++;  
         }         
         
         adr = MathRound((adr1 + adr5 + adr10 + adr20) / 4.0);
      }
      
      //== Todays Range and Room ====================================
      int t, RmUp, RmDn, RmLmt;
      
      iD1 = iBarShift(Symbol(),PERIOD_D1,Time[i],false);
      int StartOfDay   = iBarShift(NULL, 0, iTime(NULL,PERIOD_D1,iD1), false);

      int lowerLowBar  = iLowest  (NULL, 0, MODE_LOW,  StartOfDay-i+1, i); //-- count = number of periods
      int higherHighBar= iHighest (NULL, 0, MODE_HIGH, StartOfDay-i+1, i); //-- start = bar that the data should be taken from
      
      double low0  = iLow (NULL, 0, lowerLowBar);
      double high0 = iHigh(NULL, 0, higherHighBar);

      t = MathRound((high0 - low0) / Point);  //##
      RmUp =  MathRound(adr - (Close[i] - low0) / Point);
      RmDn =  MathRound(adr - (high0 - Close[i]) / Point);
      RmLmt = MathRound(adr * RoomLimitRatio);
      
      bool bRangeUp = (RmUp > RmLmt);  //##
      bool bRangeDn = (RmDn > RmLmt);  //##

            //=======================================================
            //       current bar color
            //=======================================================
      bool barColorUPM15= (Close[i] > Open[i]);
      bool barColorDNM15= (Close[i] < Open[i]);
            
            //=======================================================
            //       check signals
            //=======================================================
      if (Comment_CheckSignals)
      {
         bool showComments;
         string sCheckedTime;
         if (Check_DateTime != "")
         {
            showComments= (Time[i] == StrToTime(Check_DateTime));
            if (showComments) sCheckedTime= Check_DateTime;
         }
         else 
         {
            showComments= (i==0);
            if (showComments) sCheckedTime= TimeToStr(Time[i]);
         }
         
         if (showComments)
         {  
            string sHashiH4 = "HashiUpH4 = "+BoolToStr(bHashiUpH4)+  "  HashiDnH4 = " + BoolToStr(bHashiDnH4) +"\n";
            string sHashiH1 = "HashiUpH1 = "+BoolToStr(bHashiUpH1)+  "  HashiDnH1 = " + BoolToStr(bHashiDnH1) +"\n";
            string sHashiM15= "HashiUpM15= "+BoolToStr(bHashiUpM15)+ "  HashiDnM15= " + BoolToStr(bHashiDnM15)+"\n";
            string sAllHashi= "AllHashiUp= "+BoolToStr(bHashiUp)+    "  AllHashiDn= " + BoolToStr(bHashiDn)   +"\n";
            string sStartOfDay    = "StartOfDay_Bar= " + StartOfDay + "  [" + TimeToStr(Time[StartOfDay]) + "]\n";
            string slowerLowBar   = "LowerLow_Bar  = " + lowerLowBar + "  [" + TimeToStr(Time[lowerLowBar]) + "]\n";
            string shigherHighBar = "HigherHigh_Bar= " + higherHighBar + "  [" + TimeToStr(Time[higherHighBar]) + "]\n";
            string sBarColorM15= "BarColor UP= " + BoolToStr(barColorUPM15) + "  DN= " + BoolToStr(barColorDNM15) + "\n";
            
            bool bConditionsM15UP= (bHashiUpM15 && bRangeUp && bAtrFilter && barColorUPM15);
            bool bConditionsM15DN= (bHashiDnM15 && bRangeDn && bAtrFilter && barColorDNM15);
            bool bConditionsAllUP= (bHashiUp && bRangeUp && bAtrFilter && barColorUPM15);
            bool bConditionsAllDN= (bHashiDn && bRangeDn && bAtrFilter && barColorDNM15);
            
            Comment(
               "[time= ",sCheckedTime,"]\n",               
               //"ATR_5= ",DoubleToStr(atr1,0),
               //"  ATR_25= ",DoubleToStr(atr2,0),
               "ATR_5= ",DoubleToStr(AtrBuffer1/Point,1),
               "  ATR_25= ",DoubleToStr(AtrBuffer2/Point,1),               
               "  AtrFilter= ",BoolToStr(bAtrFilter),"\n\n",               
               sHashiH4,
               sHashiH1,
               sHashiM15,
               sAllHashi,"\n",
               sBarColorM15,"\n",
               "Todays range= ",t,"  ADR= ",adr,"\n",
               "checked bar ",i,":\n",
               sStartOfDay,
               slowerLowBar,
               shigherHighBar,
               "Close= ",DoubleToStr(Close[i],Digits), ";  LowD1= ",DoubleToStr(low0,Digits),"  HighD1= ",DoubleToStr(high0,Digits),"\n\n",
               "RmUp= ",RmUp, "  RmDn= ",RmDn, ";  RmLmt= ",RmLmt,"\n",
               "RangeUp=",BoolToStr(bRangeUp), "  RangeDn= ",BoolToStr(bRangeDn),"\n\n",
               "M15 conditions UP= ",BoolToStr(bConditionsM15UP),"  DN=",BoolToStr(bConditionsM15DN),"\n",
               "All conditions   UP= ",BoolToStr(bConditionsAllUP),"  DN=",BoolToStr(bConditionsAllDN)
            );
         }
      }
      
      //== Filter ===================================================
      if (Draw_M15Histograms) 
      {
         bool bHistogramUp=bHashiUpM15;
         bool bHistogramDn=bHashiDnM15;
      }
      else
      {
         bHistogramUp=bHashiUp;
         bHistogramDn=bHashiDn;
      }
      
      //-- long trades ----------------
      if (bHistogramUp && bRangeUp && bAtrFilter && barColorUPM15)
      {
         filterUpOK[i]= indValue;
         filterDnOK[i]= EMPTY_VALUE;
         filterNOK[i] = EMPTY_VALUE;
         if (bHashiUp && newVertLine)
         {
            //-- vertical lines -----------------
            if (Draw_SignalLines)
               Draw_VLine(i,OP_BUY);
            //-- trading arrows -----------------
            if (Draw_TradingArrows)
               Draw_EntryArrow(i,OP_BUY);
            //-- signal arrows -------------------
            if (Draw_SignalArrows)
            {
               SignalUp[i]= indValue + sigOffset;
               SignalDn[i]= EMPTY_VALUE;
            }
            else
            {
               SignalUp[i]= EMPTY_VALUE;
               SignalDn[i]= EMPTY_VALUE;
            }
            newVertLine= false;
         }
      }
      else
      //-- short trades ---------------
      if (bHistogramDn && bRangeDn && bAtrFilter && barColorDNM15)
      {
         filterUpOK[i]= EMPTY_VALUE;
         filterDnOK[i]= indValue;
         filterNOK[i] = EMPTY_VALUE;
         if (bHashiDn && newVertLine)
         {
            //-- vertical lines -----------------
            if (Draw_SignalLines)
               Draw_VLine(i,OP_SELL);
            //-- trading arrows -----------------
            if (Draw_TradingArrows)
               Draw_EntryArrow(i,OP_SELL);
            //-- signal arrows -------------------
            if (Draw_SignalArrows)
            {
               SignalUp[i]= EMPTY_VALUE;
               SignalDn[i]= indValue + sigOffset;
            }
            else
            {
               SignalUp[i]= EMPTY_VALUE;
               SignalDn[i]= EMPTY_VALUE;
            }
            newVertLine= false;
         }
      }
      else
      //-- no trades ------------------
      {
         filterUpOK[i]= EMPTY_VALUE;
         filterDnOK[i]= EMPTY_VALUE;
         filterNOK[i] = indValue;
         SignalUp[i]= EMPTY_VALUE;
         SignalDn[i]= EMPTY_VALUE;
         newVertLine= true;
      }
   }   
//----
   return(0);
}
//+------------------------------------------------------------------+


//____________________________________________________________________
void Draw_VLine(int iBar, int iOrder)
{
color dColor;
string sObjName;
   if (iOrder==OP_BUY) 
   {
      dColor=indicator_color1; //Green; 
      sObjName = "SignalBuy_";
   }
   else 
   {
      dColor=indicator_color2;
      sObjName = "SignalSell_";
   }
   
   sObjName = sObjName + TimeToStr(Time[iBar]);
   Delete_Objects(sObjName);
   
   ObjectCreate(sObjName,OBJ_VLINE,0, Time[iBar],0);
   ObjectSet(sObjName,OBJPROP_COLOR,dColor);
   ObjectSet(sObjName,OBJPROP_WIDTH,1);
   ObjectSet(sObjName,OBJPROP_STYLE,STYLE_DASHDOT);
}

//____________________________________________________________________
void Draw_EntryArrow(int iBar, int iOrder)
{
color dColorEntry= DarkOrange;
color dColorStoploss= Magenta;
color dColorTarget  = DodgerBlue;
string sObjName;
double dEntry,dStoploss,dTarget;

   int i1= iBar-1;   
   if (i1<0) return;
   
   if (iOrder==OP_BUY) 
   {
      dEntry= High[iBar];
      dStoploss= dEntry - Stoploss_Points*dPoint;
      dTarget  = dEntry + Target_Points*dPoint;
   }
   else 
   {
      dEntry= Low[iBar];
      dStoploss= dEntry + Stoploss_Points*dPoint;
      dTarget  = dEntry - Target_Points*dPoint;
   }
   
   //-- entry   
   sObjName = "SignalTradeEN_" + TimeToStr(Time[i1]);
   Delete_Objects(sObjName);   
   ObjectCreate(sObjName,OBJ_ARROW,0, Time[i1],dEntry);
   ObjectSet(sObjName,OBJPROP_COLOR,dColorEntry);
   ObjectSet(sObjName,OBJPROP_WIDTH,1);
   ObjectSet(sObjName,OBJPROP_ARROWCODE,4);
   
   //-- stop loss
   sObjName = "SignalTradeSL_" + TimeToStr(Time[i1]);
   Delete_Objects(sObjName);   
   ObjectCreate(sObjName,OBJ_ARROW,0, Time[i1],dStoploss);
   ObjectSet(sObjName,OBJPROP_COLOR,dColorStoploss);
   ObjectSet(sObjName,OBJPROP_WIDTH,1);
   ObjectSet(sObjName,OBJPROP_ARROWCODE,4);

   //-- target
   sObjName = "SignalTradeTP_" + TimeToStr(Time[i1]);
   Delete_Objects(sObjName);   
   ObjectCreate(sObjName,OBJ_ARROW,0, Time[i1],dTarget);
   ObjectSet(sObjName,OBJPROP_COLOR,dColorTarget);
   ObjectSet(sObjName,OBJPROP_WIDTH,1);
   ObjectSet(sObjName,OBJPROP_ARROWCODE,4);
}

//___________________________________________________________________
void Delete_Objects(string sText)
{
   int total = ObjectsTotal();
   for (int i = total-1; i>= 0; i--)
   {
      string sObjectName = ObjectName(i);
      if (StringFind(sObjectName, sText, 0) != -1) {
         ObjectDelete(sObjectName);
      }
   }   
   return;
}

//___________________________________________________________________
string BoolToStr(bool bValue)
{
   if (bValue) return ("true"); else return("false");
}